namespace HermesSocketServer.Requests
{
    public class RequestResult
    {
        public bool Success;
        public object? Result;
        public bool NotifyClientsOnAccount;

        private RequestResult(bool success, object? result, bool notifyClientsOnAccount = true)
        {
            Success = success;
            Result = result;
            NotifyClientsOnAccount = notifyClientsOnAccount;
        }

        public static RequestResult Successful(object? result, bool notifyClientsOnAccount = true)
        {
            return new RequestResult(true, result, notifyClientsOnAccount);
        }

        public static RequestResult Failed(string error, bool notifyClientsOnAccount = true)
        {
            return new RequestResult(false, error, notifyClientsOnAccount);
        }
    }
}